/*
 *  allocates and connects available interrupt vector 
 *
 */

#ifndef lint
static char rcsid[] =
    "@(#) $Header: /rsg/radar/src/lib/vxsupport/RCS/iVecAlloc.c,v 1.1 1993/09/01 13:59:05 vanandel Exp vanandel $(LBL)";
#endif

/*
    @(#) $Log: iVecAlloc.c,v $
 * Revision 1.1  1993/09/01  13:59:05  vanandel
 * Initial revision
 *
 * Revision 1.2  90/06/20  09:45:36  wbrown
 * made style aestheticly correct?
 * 
 * Revision 1.1  90/06/15  13:22:43  wbrown
 * Initial revision
 * 
 * 
 */

#include <vxWorks.h>
#include <intLib.h>
#include <iv.h>
#include <taskLib.h>
#include <types.h>


u_char
iVecAlloc( routine, parameter )
/*
 *
 *  find next available interrupt vector and attach intConnect()
 *	specified function, parameter.
 *  returns interrupt number, or 0 if error
 */
FUNCPTR routine;	/* routine to be called 		*/
int parameter;		/* parameter to be passed to routine	*/
{
    FUNCPTR *j;
    STATUS status;

    for ( j = IV_USER_191; j >= IV_USER_0; j-- )
    {
	if ( irqVecCheck( j ) == OK )
	{
	    taskLock();
	    if ( irqVecCheck( j ) == OK )
	    {
		status = intConnect( j, routine, parameter );
		taskUnlock();
		if ( status == OK )
		{
		    return( (u_char)IVEC_TO_INUM(j) );
		}
		else
		{
		    break;
		}
	    }
	    taskUnlock();
	}
    }
    return( (u_char)0 );
}

STATUS
irqVecCheck( irqVec )
/*
 *
 *  be sure interrupt vector is uninitialized
 */
FUNCPTR *irqVec;
{
    if ( *irqVec != (FUNCPTR)( intVecGet(IV_UNITIALIZED_INTERRUPT) ) )
    {
	return( ERROR );
    }
    else
    {
	return( OK );
    }
}
/*

						-bill
						wlbrown@lbl.gov


Disclaimer:  These opinions are my own and have nothing to do with the
    official policy or management of L.B.L, who probably couldn't care 
    less about employees who play with trains.
*/
